#!/usr/bin/perl -w

use strict;
use warnings;

sub pluginsauslesen {

my $line="";
my $file="";

my @config=();
my @pluginsconfig=();

my $Verzeichnis = "/etc/remote-nagios/plugins-config/";

opendir(DIR, $Verzeichnis) || die "$Verzeichnis: $!";
my @files = readdir(DIR);
closedir(DIR);

foreach $file (@files) {
 if ($file!~/\A\./){
  open(DATEI, "<$Verzeichnis/$file") || die "Datei nicht gefunden";
  push(@config,<DATEI>);
  close(DATEI);
 }
}

my $i=0;
my %plugin=();
my $command_tmp="";

my $key="";
my $value="";

foreach $line (@config) { 

if ($line!~ /#/) {
  chomp($line);
  $line =~ s/^\s+//;
  
  if ($line=~ /command_name/) {
   $i++;
   ($key,$value) = split (/\s+/, $line);
   $command_tmp=$value;
  }

  if ($line=~ /command_line/) {
   $line =~ s/^command_line\s+//;
   $plugin{"$command_tmp"}=$line;
   $command_tmp="";
  }
 
 }
}

open(DATEI, "</etc/remote-nagios/rnagios-plug.conf") || die "Datei nicht gefunden";
push(@pluginsconfig,<DATEI>);
close(DATEI);

my %pluginconfig=();
my @checkline=();
my $I=0;

foreach $line (@pluginsconfig) {
 if (($line!~ /^#/)&&($line!~ /^$/)) {
  chomp($line);
  
  my @vars=split (/\!/, $line);
  my $servicename=$vars[0];

  
  $checkline[$I]{"command"}=$plugin{"$servicename"};
  $checkline[$I]{"name"}=$line;
  $I++;
 }
}
return @checkline;
}
1
